#include <cstdio>
#include <cstdlib>
#include <cstring>

#define MM 16
#define MAX 128
#define NUM_ITERS 100000
FILE* in; FILE* out;

int n, m, k;
double simulate()
{
	double sum = 0;
	int dir[4][2] = { {-1, 0}, {0, 1}, {1, 0}, {0, -1} };

	for (int iter = 0; iter < NUM_ITERS; iter++)
	{
		char board[MM][MM];
		char marked[MM][MM];
		int pos[MAX][2], cnt = 0;
		memset(board, 0, sizeof(board));
		memset(marked, 0, sizeof(marked));
		
		for (int i = 0; i < k; i++)
		{
			int row = rand() % n, col = rand() % m;
			while (board[row][col]) {row = rand() % n; col = rand() % m;}
			board[row][col] = 1;
			pos[cnt][0] = row; pos[cnt][1] = col; cnt++;
		}
		
		int rem = n * m;
		int topRow = 0, bottomRow = n - 1;
		int leftCol = 0, rightCol = m - 1;
		while (rem > 2 && cnt >= 2)
		{
			int moveRow = 0;
			if (leftCol >= rightCol) moveRow = 1;
			else if (topRow >= bottomRow) moveRow = 0;
			else moveRow = rand() % 2;
			
			// Remove row
			if (moveRow)
			{
				// Remove top row
				if (rand() % 2)
				{
					for (int i = leftCol; i <= rightCol; i++) marked[topRow][i] = 1, rem--;
					topRow++;
				}
				// Remove bottom row
				else
				{
					for (int i = leftCol; i <= rightCol; i++) marked[bottomRow][i] = 1, rem--;
					bottomRow--;
				}
			}
			// Remove col
			else
			{
				// Remove left column
				if (rand() % 2)
				{
					for (int i = topRow; i <= bottomRow; i++) marked[i][leftCol] = 1, rem--;
					leftCol++;
				}
				// Remove right column
				else
				{
					for (int i = topRow; i <= bottomRow; i++) marked[i][rightCol] = 1, rem--;
					rightCol--;
				}
			}
			
			// Move pieces
			for (int i = 0; i < cnt; i++)
			{
				int can[4][2], ccnt = 0;
				for (int c = 0; c < 4; c++)
				{
					int nrow = pos[i][0] + dir[c][0]; if (nrow < topRow || nrow > bottomRow) continue;
					int ncol = pos[i][1] + dir[c][1]; if (ncol < leftCol || ncol > rightCol) continue;
					if (marked[nrow][ncol]) continue;
					can[ccnt][0] = nrow; can[ccnt][1] = ncol; ccnt++;
				}
				int idx = rand() % ccnt;
				board[pos[i][0]][pos[i][1]]--;
				pos[i][0] = can[idx][0]; pos[i][1] = can[idx][1];
				board[pos[i][0]][pos[i][1]]++;
			}
			
			// Fix parity
			int npos[MAX][2], ncnt = 0;
			for (int i = 0; i < cnt; i++)
			{
				if (board[pos[i][0]][pos[i][1]] % 2 == 1)
				{
					npos[ncnt][0] = pos[i][0];
					npos[ncnt][1] = pos[i][1];
					ncnt++;
				}
				board[pos[i][0]][pos[i][1]] = 0;
			}
			cnt = ncnt;
			for (int i = 0; i < ncnt; i++)
			{
				pos[i][0] = npos[i][0];
				pos[i][1] = npos[i][1];
				board[pos[i][0]][pos[i][1]] = 1;
			}
		}
		sum += cnt;
	}
	return sum / NUM_ITERS;
}

int main(void)
{
        in = stdin; out = stdout;
//        in = fopen("Ants.in", "rt"); out = fopen("Ants.out", "wt");

        fscanf(in, "%d %d %d", &n, &m, &k);
        double ans = simulate();
        char buff[32];
        sprintf(buff, "%.2lf\n", ans);
        sscanf(buff, "%lf\n", &ans);
        fprintf(out, "%.6lf\n", ans);

        return 0;
}
