/*
ID: espr1t
LANG: C++
TASK: Ants
COMP: National Olympiad in Informatics, V. Tarnovo, 2012
KEYWORDS: Dynamic Programming, Probability, Math
*/

#include <cstdio>
#define MAX 128
FILE* in; FILE* out;

int n, m, k;
double dyn[MAX][MAX][2][2];

double recurse(int idx, int rem, int p0, int p1)
{
        if (rem == 0) return p0 + p1;
        if (dyn[idx][rem][p0][p1] >= -1)
                return dyn[idx][rem][p0][p1];

        double ans = 0.0;
        double chance = (double)rem / (double)(n * m - idx);
        if (rem < n * m - idx) ans += (1.0 - chance) * recurse(idx + 1, rem, p0, p1);
        if (rem > 0) ans += chance * recurse(idx + 1, rem - 1, (p0 + !(idx & 1)) % 2, (p1 + (idx & 1)) % 2);
        return dyn[idx][rem][p0][p1] = ans;
}

int main(void)
{
        in = stdin; out = stdout;
//        in = fopen("Ants.in", "rt"); out = fopen("Ants.out", "wt");

        fscanf(in, "%d %d %d", &n, &m, &k);
        for (int i = 0; i < MAX; i++)
                for (int r = 0; r < MAX; r++)
                        for (int c = 0; c < 2; c++)
                                for (int j = 0; j < 2; j++)
                                        dyn[i][r][c][j] = -42;
        fprintf(out, "%.6lf\n", recurse(0, k, 0, 0));
        return 0;
}
