#include <cstdio>
#include <cstdlib>

int tests[21][3] = {
	{1, 5, 2},		// 0
	{1, 8, 5},		// 1
	{1, 4, 2},		// 2
	{1, 6, 4},		// 3
	{1, 7, 4},		// 4
	{1, 8, 2},		// 5
	{1, 8, 4},		// 6
	{1, 8, 6},		// 7
	{1, 10, 2},		// 8
	{1, 10, 6},		// 9
	{1, 10, 10},	// 10
	{3, 6, 7},		// 11
	{3, 6, 2},		// 12
	{3, 5, 2},		// 13
	{10, 10, 4},	// 14
	{3, 5, 4},		// 15
	{10, 9, 8},		// 16
	{9, 9, 6},		// 17
	{6, 7, 8},		// 18
	{8, 7, 6},		// 19
	{6, 6, 6}		// 20
};

#define MAX 128

int n, m, k;
double dyn[MAX][MAX][2][2];

double recurse(int idx, int rem, int p0, int p1)
{
        if (rem == 0) return p0 + p1;
        if (dyn[idx][rem][p0][p1] >= -1)
                return dyn[idx][rem][p0][p1];

        double ans = 0.0;
        double chance = (double)rem / (double)(n * m - idx);
        if (rem < n * m - idx) ans += (1.0 - chance) * recurse(idx + 1, rem, p0, p1);
        if (rem > 0) ans += chance * recurse(idx + 1, rem - 1, (p0 + !(idx & 1)) % 2, (p1 + (idx & 1)) % 2);
        return dyn[idx][rem][p0][p1] = ans;
}

int main(void)
{
	int numTests = 20;
	for (int test = 0; test <= numTests; test++)
	{
		fprintf(stderr, "Currently at test %d...\n", test);
		FILE* out;
		char fileName[32];
		
		n = tests[test][0]; m = tests[test][1]; k = tests[test][2];

        for (int i = 0; i < MAX; i++)
                for (int r = 0; r < MAX; r++)
                        for (int c = 0; c < 2; c++)
                                for (int j = 0; j < 2; j++)
                                        dyn[i][r][c][j] = -42;
		double ans = recurse(0, k, 0, 0);
		fprintf(stderr, "    >> current answer was %.6lf\n", ans);
		
		
		// Print input file
		sprintf(fileName, "Ants.%02d.in", test);
		out = fopen(fileName, "wt");
		fprintf(out, "%d %d %d\n", n, m, k);

		// Additional string
		int remRows = n, remCols = m;
		for (int i = 0; i < n + m - 3; i++)
		{
			int useRow = rand() % 2;
			if (useRow == 0 && remCols <= 1) useRow = 1;
			if (useRow == 1 && remRows <= 1) useRow = 0;
			if (useRow)
				{fprintf(out, "%c", (rand() % 2) ? 'T' : 'B'); remRows--;}
			else
				{fprintf(out, "%c", (rand() % 2) ? 'L' : 'R'); remCols--;}
		}
		fprintf(out, "\n");
		fclose(out);
		
		// Print solution file
		sprintf(fileName, "Ants.%02d.sol", test);
		out = fopen(fileName, "wt");
		fprintf(out, "%.6lf\n", ans);
		fclose(out);
	}
	fprintf(stderr, "Finished all tests successfully!\n");
	system("pause");
	return 0;
}
