#include <algorithm>
#include <cstdio>
#include <vector>
#include <queue>
using namespace std;

bool isPrime(int n)
{ // naive
  if(n==0) return false;
  if(n==1) return false;
  if(n==2) return true;
  if(n%2==0) return false;
  for(int i=3;i<n;i+=2)
   if(n%i==0) return false;
  return true;
}

typedef vector<int> vi;

#define MAX_V 2006
#define oo 1000000000

int a0[1001];
int a1[1001];
int n0, n1;

int s,t;
int res[MAX_V][MAX_V];

void create()
{
  int n;
  scanf("%d",&n);
  for(int i=0;i<n;i++)
  { int v; scanf("%d",&v);
    if(v%2==0) {a0[n0]=v; n0++;}
    else {a1[n1]=v; n1++;}
  }   
  
  s=0;
  t=1;
  for(int i=0;i<n0;i++) {res[0][i+2]=1;}
  for(int j=0;j<n1;j++) {res[n0+j+2][1]=1;}
  for(int i=0;i<n0;i++)
  for(int j=0;j<n1;j++)
   if(isPrime(a0[i]+a1[j])) 
       res[i+2][n0+j+2]=1;
}

int mf, f;                          
vi p;

void augment(int v, int minEdge) 
{// traverse BFS spanning tree from s to t
  if (v == s) { f = minEdge; return; }  
  else if (p[v] != -1) { augment(p[v], min(minEdge, res[p[v]][v])); 
                         res[p[v]][v] -= f; res[v][p[v]] += f; }       
}

int max_flow() 
{
  mf = 0;                                              
  while (1) 
  {// O(VE^2) (actually O(V^3E) Edmonds Karp's algorithm
    f = 0;
    //BFS
    vi dist(MAX_V, oo); dist[s] = 0; queue<int> q; q.push(s);
    p.assign(MAX_V, -1);           
    while (!q.empty()) {
      int u = q.front(); q.pop();
      if (u == t) break;      
      for (int v = 0; v < MAX_V; v++)                 
        if (res[u][v] > 0 && dist[v] == oo)
          dist[v] = dist[u] + 1, q.push(v), p[v] = u;
    }
    augment(t, oo);     
    if (f == 0) break;      
    mf += f;                 
  }
  return mf;                         
}

int main()
{
  create();
  int sol=max_flow();
  printf("%d\n", mf); 
}
